#include <iostream>
#include <vector>
#include <list>
#include <array>

#include "getSequence.h"

template<typename T = int>
auto getArithmeticSequence(unsigned int n, T a1 = 0, T d = 1)
{
    auto seq = std::vector<T>();

    for(int i = 0; i < n; ++i)
    {
       seq.push_back(a1 + static_cast<T>(n-1) * d); 
    }

    return seq;
}

template<typename SeqType>
auto calculateSum(SeqType seq)
{
    double sum = 0;

    for(auto s : seq)
    {
        sum += s;
    }

    return sum;
}

int main()
{
    std::cout << "witaj! \n";

    std::cout << calculateSum(getSequence()) << std::endl;
    std::cout << calculateSum(getArithmeticSequence<double>(10)) << std::endl;
    std::cout << calculateSum(getArithmeticSequence(10, 1, 20)) << std::endl; 

    return 0;
}